"use strict"
// базовый общий для всех
XHEBaseObject = require("../../xhe_base.js")

/////////////////////////////////////////// Plgn_CollectionsArray ////////////////////////////////////////
class XHECOLLECTIONSARRAY extends XHEBaseObject
{
///////////////////////////////// SERVICE FUNCTIONS ////////////////////////////////////////////////
    // server initialization
    constructor(server, password = "") {
	    super(server, password, "Plgn_CollectionsArray")
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////

    // Действие создаёт новый пустой экземпляр коллекции.
    new_list_collection() {
        const params = []
        return this.call_get("new_list_collection", params)
    }

    // Добавляет указанное значение в конец выбранной коллекции
    add_value_to_list(collection, valueToAdd) {
        const params = ["collection", collection, "valueToAdd", valueToAdd]
        return this.call_get("add_value_to_list", params)
    }

    // Действие копирует часть списка обозначенной длины, начиная с указанного индекса, исключая крайнее значение в этих рамках, и возвращает ее как новый список
    copy_part_list(collection, startIndex, length) {
        const params = ["collection", collection, "startIndex", startIndex, "length", length]
        return this.call_get("copy_part_list", params)
    }

    // Действие вставляет коллекцию в список по индексу
    insert_collection_at_index(collection, index, insertCollection) {
        const params = ["collection", collection, "index", index, "insertCollection", insertCollection]
        return this.call_get("insert_collection_at_index", params)
    }

    // Действие соединяет две коллекции в установленном порядке.
    merge_collections(firstCollection, secondCollection) {
        const params = ["firstCollection", firstCollection, "secondCollection", secondCollection]
        return this.call_get("merge_collections", params)
    }

    // Действие удаляет из списка элементы указанной коллекции
    remove_elements(firstCollection, secondCollection) {
        const params = ["firstCollection", firstCollection, "secondCollection", secondCollection]
        this.call_get("remove_elements", params)
    }

    // Действие удаляет элементы коллекции в заданном диапазоне
    remove_range(collection, startIndex=0, endIndex=-1) {
        const params = ["collection", collection, "startIndex", startIndex, "endIndex", endIndex]
        return this.call_get("remove_range", params)
    }

    // Действие меняет порядок элементов в указанном списке на противоположный
    reverse(collection) {
        const params = ["collection", collection]
        this.call_get("reverse", params)
    }

    // Действие заменяет значение в списке по индексу
    replace_at_index(collection, index, newValue) {
        const params = ["collection", collection, "index", index, "newValue", newValue]
        this.call_get("replace_at_index", params)
    }

    // Сортирует коллекцию в указанном порядке
    sort(collection, ascendingOrder=true) {
        const params = ["collection", collection, "ascendingOrder", ascendingOrder]
        return this.call_get("sort", params)
    }

    // Действие получает количество элементов в коллекции или массиве
    get_length_of_list(collection) {
        const params = ["collection", collection]
        return this.call_get("get_length_of_list", params)
    }

    // Действие проверяет, содержит ли выбранная коллекция указанный объект
    contains_value(collection, valueToCheck) {
        const params = ["collection", collection, "valueToCheck", valueToCheck]
        return this.call_get("contains_value", params)
    }

    // Действие возвращает отсчитываемый от нуля индекс первого вхождения значения в списке
    find_first_index(collection, value) {
        const params = ["collection", collection, "value", value]
        return this.call_get("find_first_index", params)
    }

    // Действие возвращает индекс последнего вхождения элемента в списке
    find_last_index(collection, value) {
        const params = ["collection", collection, "value", value]
        return this.call_get("find_last_index", params)
    }

    // Действие возвращает значение элемента, порядковый номер позиции которого равен указанному.
    get_value_by_index(collection, index) {
        const params = ["collection", collection, "index", index]
        return this.call_get("get_value_by_index", params)
    }

    // Действие для перевода списка в строку (для теста фенкционала плагина)
    list_to_string(collection) {
        const params = ["collection", collection]
        return this.call_get("list_to_string", params)
    }
}
module.exports = XHECOLLECTIONSARRAY
