<?php
/////////////////////////////////////////// Plgn_CollectionsArray //////////////////////////////////////
class XHECOLLECTIONSARRAY extends XHEBaseObject
{
//////////////////////////// SERVICE FUNCTIONS /////////////////////////////////////////////////////
    // server initialization
    private string $inner_number;

    function __construct(string $server, string $password="")
	{
		$this->server = $server;
		$this->password = $password;
		$this->prefix = "Plgn_CollectionsArray";
	}
/////////////////////////////////////////////////////////////////////////////////////////////////////    
    
    // Действие создаёт новый пустой экземпляр коллекции.
    function new_list_collection(): string
    {
        $params = array(  );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Добавляет указанное значение в конец выбранной коллекции
    function add_value_to_list(string $collection, string $valueToAdd): string
    {
        $params = array( "collection" => $collection, "valueToAdd" => $valueToAdd );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие копирует часть списка обозначенной длины, начиная с указанного индекса, исключая крайнее значение в этих рамках, и возвращает ее как новый список
    function copy_part_list(string $collection, int $startIndex, int $length): string
    {
        $params = array( "collection" => $collection, "startIndex" => $startIndex, "length" => $length );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие вставляет коллекцию в список по индексу
    function insert_collection_at_index(string $collection, int $index, string $insertCollection): string
    {
        $params = array( "collection" => $collection, "index" => $index, "insertCollection" => $insertCollection );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие соединяет две коллекции в установленном порядке.
    function merge_collections(string $firstCollection, string $secondCollection): string
    {
        $params = array( "firstCollection" => $firstCollection, "secondCollection" => $secondCollection );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие удаляет из списка элементы указанной коллекции
    function remove_elements(string $firstCollection, string $secondCollection): void
    {
        $params = array( "firstCollection" => $firstCollection, "secondCollection" => $secondCollection );
        $this->call_get(__FUNCTION__, $params);
    }

    // Действие удаляет элементы коллекции в заданном диапазоне
    function remove_range(string $collection, int $startIndex=0, int $endIndex=-1): string
    {
        $params = array( "collection" => $collection, "startIndex" => $startIndex, "endIndex" => $endIndex );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие меняет порядок элементов в указанном списке на противоположный
    function reverse(string $collection): void
    {
        $params = array( "collection" => $collection );
        $this->call_get(__FUNCTION__, $params);
    }

    // Действие заменяет значение в списке по индексу
    function replace_at_index(string $collection, int $index, string $newValue): void
    {
        $params = array( "collection" => $collection, "index" => $index, "newValue" => $newValue );
        $this->call_get(__FUNCTION__, $params);
    }

    // Сортирует коллекцию в указанном порядке
    function sort(string $collection, bool $ascendingOrder=true): string
    {
        $params = array( "collection" => $collection, "ascendingOrder" => $ascendingOrder );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие получает количество элементов в коллекции или массиве
    function get_length_of_list(string $collection): int
    {
        $params = array( "collection" => $collection );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие проверяет, содержит ли выбранная коллекция указанный объект
    function contains_value(string $collection, string $valueToCheck): bool
    {
        $params = array( "collection" => $collection, "valueToCheck" => $valueToCheck );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие возвращает отсчитываемый от нуля индекс первого вхождения значения в списке
    function find_first_index(string $collection, string $value): int
    {
        $params = array( "collection" => $collection, "value" => $value );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие возвращает индекс последнего вхождения элемента в списке
    function find_last_index(string $collection, string $value): int
    {
        $params = array( "collection" => $collection, "value" => $value );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие возвращает значение элемента, порядковый номер позиции которого равен указанному.
    function get_value_by_index(string $collection, int $index): string
    {
        $params = array( "collection" => $collection, "index" => $index );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Действие для перевода списка в строку (для теста фенкционала плагина)
    function list_to_string(string $collection): string
    {
        $params = array( "collection" => $collection );
        return $this->call_get(__FUNCTION__, $params);
    }
};

?>
