from Objects.xhe_base import *


# Plgn_CollectionsArray
class XHECOLLECTIONSARRAY(XHEBaseObject):
    # server initialization
    def __init__(self, server: str, password: str=""):
        self.server = server
        self.password = password
        self.prefix = "Plgn_CollectionsArray"


    # Действие создаёт новый пустой экземпляр коллекции.
    def new_list_collection(self) -> str:
        params = {}
        return self.call_get("new_list_collection", params)


    # Добавляет указанное значение в конец выбранной коллекции
    def add_value_to_list(self, collection: str, valueToAdd: str) -> str:
        params = {"collection": collection, "valueToAdd": valueToAdd}
        return self.call_get("add_value_to_list", params)


    # Действие копирует часть списка обозначенной длины, начиная с указанного индекса, исключая крайнее значение в этих рамках, и возвращает ее как новый список
    def copy_part_list(self, collection: str, startIndex: int, length: int) -> str:
        params = {"collection": collection, "startIndex": startIndex, "length": length}
        return self.call_get("copy_part_list", params)


    # Действие вставляет коллекцию в список по индексу
    def insert_collection_at_index(self, collection: str, index: int, insertCollection: str) -> str:
        params = {"collection": collection, "index": index, "insertCollection": insertCollection}
        return self.call_get("insert_collection_at_index", params)


    # Действие соединяет две коллекции в установленном порядке.
    def merge_collections(self, firstCollection: str, secondCollection: str) -> str:
        params = {"firstCollection": firstCollection, "secondCollection": secondCollection}
        return self.call_get("merge_collections", params)


    # Действие удаляет из списка элементы указанной коллекции
    def remove_elements(self, firstCollection: str, secondCollection: str) -> None:
        params = {"firstCollection": firstCollection, "secondCollection": secondCollection}
        self.call_get("remove_elements", params)


    # Действие удаляет элементы коллекции в заданном диапазоне
    def remove_range(self, collection: str, startIndex: int=0, endIndex: int=-1) -> str:
        params = {"collection": collection, "startIndex": startIndex, "endIndex": endIndex}
        return self.call_get("remove_range", params)


    # Действие меняет порядок элементов в указанном списке на противоположный
    def reverse(self, collection: str) -> None:
        params = {"collection": collection}
        self.call_get("reverse", params)


    # Действие заменяет значение в списке по индексу
    def replace_at_index(self, collection: str, index: int, newValue: str) -> None:
        params = {"collection": collection, "index": index, "newValue": newValue}
        self.call_get("replace_at_index", params)


    # Сортирует коллекцию в указанном порядке
    def sort(self, collection: str, ascendingOrder: bool=True) -> str:
        params = {"collection": collection, "ascendingOrder": ascendingOrder}
        return self.call_get("sort", params)


    # Действие получает количество элементов в коллекции или массиве
    def get_length_of_list(self, collection: str) -> int:
        params = {"collection": collection}
        return self.call_get("get_length_of_list", params)


    # Действие проверяет, содержит ли выбранная коллекция указанный объект
    def contains_value(self, collection: str, valueToCheck: str) -> bool:
        params = {"collection": collection, "valueToCheck": valueToCheck}
        return self.call_get("contains_value", params)


    # Действие возвращает отсчитываемый от нуля индекс первого вхождения значения в списке
    def find_first_index(self, collection: str, value: str) -> int:
        params = {"collection": collection, "value": value}
        return self.call_get("find_first_index", params)


    # Действие возвращает индекс последнего вхождения элемента в списке
    def find_last_index(self, collection: str, value: str) -> int:
        params = {"collection": collection, "value": value}
        return self.call_get("find_last_index", params)


    # Действие возвращает значение элемента, порядковый номер позиции которого равен указанному.
    def get_value_by_index(self, collection: str, index: int) -> str:
        params = {"collection": collection, "index": index}
        return self.call_get("get_value_by_index", params)


    # Действие для перевода списка в строку (для теста фенкционала плагина)
    def list_to_string(self, collection: str) -> str:
        params = {"collection": collection}
        return self.call_get("list_to_string", params)

